#include <stdbool.h>

enum Waypoint // Die "komischen" Zahlenwerte sorgen fr ein schnes Bild im Debugger.
{
  u = 0xB7, w = 0x23, s = 0x2A,
  left = 0x3C, up = 0x5E, right = 0x3E, down = 0x76
};
typedef enum Waypoint Waypoint;
// in C++ usw: const int WIDTH = 8;
#define WIDTH 8
#define HEIGHT 8
Waypoint labyrinth[HEIGHT][WIDTH] =
{
  {w,w,w,w,w,w,w,w},
  {w,u,w,u,u,u,s,w},
  {w,u,w,w,w,u,u,w},
  {w,u,w,u,u,u,w,w},
  {w,u,u,u,w,u,u,w},
  {u,u,u,u,w,w,w,w},
  {w,u,w,u,u,u,u,w},
  {w,w,w,w,w,w,w,w}
};

bool checkNeighbors(int x, int y)
{
  // oben?
  if(labyrinth[y-1][x] == u)
  {
    labyrinth[y-1][x] = down;
    if(y-1 == 0 || checkNeighbors(x, y-1))
    {
      return true;
    }
  }
    
  // rechts?
  if(labyrinth[y][x+1] == u)
  {
    labyrinth[y][x+1] = left;
    if(x+1 == WIDTH - 1 || checkNeighbors(x+1, y))
    {
      return true;
    }
  }      
  
  // unten?
  if(labyrinth[y+1][x] == u)
  {
    labyrinth[y+1][x] = up;
    if(y+1 == HEIGHT - 1 || checkNeighbors(x, y+1))
    {
      return true;
    }
  }

  // links?
  if(labyrinth[y][x-1] == u)
  {
    labyrinth[y][x-1] = right;
    if(x-1 == 0 || checkNeighbors(x-1, y))
    {
      return true;
    }
  }
  
  return false;
}

int main( void )
{
  bool solved = checkNeighbors(6, 1);
  
  return 0;
}
